--[[ 

Group Tags

Revision History:
-----------------
.
. 0.3.0 - Save color and enabled flags between sessions.
. 0.2.0 - First public release.
.

]]--

gtags_roster = {};
gtags_status_version_txt = "0.3.0";
GroupTags_Enabled = 1;
GroupTags_Color = 0;
gtags_time = 0;
local old_chat_handler;

function gtags_load()
	SlashCmdList["gtags"] = gtags_slash;
	SLASH_gtags1 = "/gtags";
	DEFAULT_CHAT_FRAME:AddMessage("Group Tags (/gtags) version "..gtags_status_version_txt.." loaded.");
	old_chat_handler = ChatFrame_OnEvent;
	ChatFrame_OnEvent = gtags_event;
end


function gtags_slash(msg)
	if (msg == "enable") then
		GroupTags_Enabled = 1;
		DEFAULT_CHAT_FRAME:AddMessage("/gtags |cff00ff00enabled");
	elseif (msg == "disable") then
		GroupTags_Enabled = 0;
		DEFAULT_CHAT_FRAME:AddMessage("/gtags |cffff0000disabled");
	elseif (msg == "refresh") then
		gtags_time = 0;
		DEFAULT_CHAT_FRAME:AddMessage("/gtags |cff8888ffrefreshing on next chat event");
	elseif (msg == "color" or msg == "colour") then
		if (GroupTags_Color == 1) then
			GroupTags_Color = 0;
		else
			GroupTags_Color = 1;
		end
		DEFAULT_CHAT_FRAME:AddMessage("/gtags |cff8888ffcolor is "..GroupTags_Color);
	else
		DEFAULT_CHAT_FRAME:AddMessage("Group Tags v"..gtags_status_version_txt);
		DEFAULT_CHAT_FRAME:AddMessage("    /gtags |cff8888ffenable");
		DEFAULT_CHAT_FRAME:AddMessage("    /gtags |cff8888ffdisable");
		DEFAULT_CHAT_FRAME:AddMessage("    /gtags |cff8888ffrefresh");
		DEFAULT_CHAT_FRAME:AddMessage("    /gtags |cff8888ffcolor");
	end
end


function gtags_refresh()
	local now = GetTime();
	if (now > gtags_time + 30) then
		gtags_roster = {};

		local name,rank,subgroup,l,c,f,z,o,d;
		local res;
		for i=1,GetNumRaidMembers() do
			name,rank,subgroup,l,c,f,z,o,d = GetRaidRosterInfo(i);
			res = {};
			res["name"] = name;
			res["rank"] = rank;
			res["subgroup"] = subgroup;
			tinsert(gtags_roster, res);
		end
		gtags_time = now;
	end
end

function gtags_event(event)
	if (event ~= 'CHAT_MSG_RAID' and event ~= 'CHAT_MSG_RAID_LEADER') then
		old_chat_handler(event);
		return;
	end
	if (GroupTags_Enabled == 0) then
		old_chat_handler(event);
		return;
	end

	gtags_refresh();

	local res = nil;
	for i=1,getn(gtags_roster) do
		if (gtags_roster[i]["name"] == arg2) then
			res = gtags_roster[i];
			break;
		end
	end
	if (res ~= nil) then
		if (GroupTags_Color == 1) then
			arg1 = "[|cffdddd00G"..res["subgroup"].."|cffFF8800]: "..arg1;
		else
			arg1 = "[G"..res["subgroup"].."]: "..arg1;
		end
	end
	old_chat_handler(event);
end

